*
      SUBROUTINE PAR_SYEV1(NAME, N, NPROCS, MMIN, NB, NPROW, NPCOL)
*
*        NB,   (NPROW,NPCOL)  
*          
*     PDSYEV1, PDSYEV3, PDSYEV5
*
*   ..
      INTEGER            N, NPROCS, MMIN, NB, NPROW, NPCOL
      CHARACTER*(*)   NAME
*
*   -   ..
      INTEGER           NPR
      PARAMETER         (NPR = 6)
*
*   ..
      INTEGER            CTXT, I, IAM, INFO, IPA, IPEV,
     $                   IPW, IPWOR, IPIWOR,
     $                   IPZ, NP, NQ, M, MXLLDA,
     $                   MYCOL, MYROW, MXNP, MXNQ, NEIG, NN,
     $                   LWOPT, LWORK, LIWORK, IA, JA,
     $                   NPS, NSYTRD, WORKSIZ
*
      INTEGER            
     $                   NPROCS1, NQB, NP0, NB0
*
*   ..
      INTEGER            ICEIL, ILCM, NUMROC
      EXTERNAL           ICEIL, ILCM, NUMROC
*
*   ..
      INTRINSIC          MAX, SQRT, INT, REAL
*
*  
*
*  
*
*    NB      NPROW, NPCOL
*
      NPROW = INT(SQRT(REAL(NPROCS)))
      NPCOL = NPROCS/NPROW
*
      NB0 = INT(REAL( N/MAX(NPROW,NPCOL) ))
      IF( NB0.LT.4 ) NB = 2
*1      NB0 = INT(REAL( N/NPROW) )
*1      IF( NB0.LT.4 ) NB = NB0
      IF( NB0.GE.4 .AND. NB0.LT.8 ) NB = 4
*
      IF( NB0.GE.8 .AND. NB0.LT.16 ) NB = 8
      IF( NB0.GE.16 .AND. NB0.LT.32 ) NB = 16
      IF( NB0.GE.32 .AND. NB0.LT.64 ) NB = 32
      IF( NB0.GE.64 .AND. NB0.LT.128 ) NB = 64
      IF( NB0.GE.128 .AND. NB0.LT.256 ) NB = 128
      IF( NB0.GE.256 .AND. NB0.LT.512 ) NB = 256
      IF( NB0.GE.512 ) NB = 512
*
*   BLACS'   
*
      MXNP = NUMROC( N, NB, 0, 0, NPROW )
      MXNQ = NUMROC( N, NB, 0, 0, NPCOL )
*
*    ( MMIN )
*
      MXLLDA = MXNP
*
*     A
      IPA = 1
*
*   EV ( )
      IPEV = IPA + MXLLDA*MXNQ
*     WORK
      IPWOR = IPEV + N
*
      IF( NAME .NE. 'PDSYEV1' ) GOTO 2
*
*   ,    PDSYEV1
*
      LWORK = 5*N + MAX( NB*( MXNP + 1 ), 3*NB ) + 1
      IPW = IPWOR + LWORK
      GOTO 3
*
    2 IF( NAME .NE. 'PDSYEV3' .AND. NAME .NE. 'PDSYEV5' ) GOTO 10
*
*   ,     PDSYEV3(5)
*
      NP0 = NUMROC( N, NB, 0, 0, NPROW )
*
      NN = MAX( N, NB, 2 )
      LWMIN = 5*N + MAX( 5*NN, NB*( NP0+1 ) )
      LWORK = LWMIN
*
      LIWORK = 6*MAX( N, NPROCS+1, 4 )
*
*     IWORK
      IPIWOR = IPWOR + LWORK
      IPW = IPIWOR + LIWORK
*
      GOTO 3
*
*     PDLAPRNT  .
*
    3 WORKSIZ = MAX( NB, MXNP )
*
*        
      MMIN = IPW + WORKSIZ
*
*      
*
        WRITE( NPR, FMT = 9992 )NAME
        WRITE( NPR, FMT = 9998 )N, N, NPROCS
        WRITE( NPR, FMT = 9997 )NPROW*NPCOL, NPROW, NPCOL, MMIN
        WRITE( NPR, FMT = 9993 )NB, NB
*
        WRITE( NPR, FMT = * )'   IPA,   IPEV,  IPWOR, IPW,  MMIN' 
        WRITE( NPR, FMT = 9994 )IPA, IPEV,IPWOR, IPW, MMIN
    5   CONTINUE
*
 9994 FORMAT( / 5I7 /)
*
   10 CONTINUE
*
 9992 FORMAT( / '    ',
     $      '       ', A7/ )
*
 9998 FORMAT( /'      A ',I2,' *',I2,',',
     $       '    ',I2 / )
 9997 FORMAT( / '    ',I3,' ,',
     $       '    ', I2, ' *', I2, ';' /
     $      '      '/
     $      '    ',
     $      I5,'  '/)
 9993 FORMAT( / '       NB ',
     $       I2,' *',I2 // '     '/)
      RETURN
      END
